#include <jmptime.h>
#if HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

jlong get_time (JVMPI_Interface* jvmpi) {
    jlong tval;
#if 1 // MARCO def HAVE_SYS_TIME_H
				/* MW: This method costs around 126
				   seconds for my test case */
    struct timeval tv;
    gettimeofday (&tv, NULL);
    tval = ((jlong)tv.tv_sec) * 1000000000ll + ((jlong)tv.tv_usec) * 1000;
#else
				/* MW: This method costs around 145
				   seconds for the same test case.
				   Overall time is currently 415
				   seconds. */
    /* currently there is a bug in the jvm, returns microsec instead of nanosec. */
    /* since this timing is wrong anyway we ignore that problem for now. */
    tval = jvmpi->GetCurrentThreadCpuTime() * 1000;
#endif
    return tval;
}

/* Emacs Local Variables: */
/* Emacs mode:C */
/* Emacs c-indentation-style:"gnu" */
/* Emacs c-hanging-braces-alist:((brace-list-open)(brace-entry-open)(defun-open after)(substatement-open after)(block-close . c-snug-do-while)(extern-lang-open after)) */
/* Emacs c-cleanup-list:(brace-else-brace brace-elseif-brace space-before-funcall) */
/* Emacs c-basic-offset:4 */
/* Emacs End: */
